<?php

class vB_PaidSubscriptionMethod_gooyapay extends vB_PaidSubscriptionMethod
{
    var $supports_recurring = false;
    var $display_feedback = true;

    function verify_payment()
    {
        $this->registry->input->clean_array_gpc('r', array(
            'item'		    => vB_Cleaner::TYPE_STR,
            'unit'		    => vB_Cleaner::TYPE_STR,
            'Authority'	    => vB_Cleaner::TYPE_STR,
            'PaymentStatus'	=> vB_Cleaner::TYPE_STR
        ));

        if (!$this->test())
        {
            $this->error = 'Payment processor not configured';
            return false;
        }

        $this->transaction_id = $this->registry->GPC['Authority'];
        if(!empty($this->registry->GPC['item']) AND !empty($this->registry->GPC['unit']) AND !empty($this->registry->GPC['Authority']))
        {
            $this->paymentinfo = $this->registry->db->query_first("
				SELECT paymentinfo.*, user.username
				FROM " . TABLE_PREFIX . "paymentinfo AS paymentinfo
				INNER JOIN " . TABLE_PREFIX . "user AS user USING (userid)
				WHERE hash = '" . $this->registry->db->escape_string($this->registry->GPC['item']) . "'
			");
            if (!empty($this->paymentinfo) && $this->registry->GPC['PaymentStatus'] == 'OK')
            {
                $sub = $this->registry->db->query_first("SELECT * FROM " . TABLE_PREFIX . "subscription WHERE subscriptionid = " . $this->paymentinfo['subscriptionid']);
                $subid = $this->paymentinfo['subscriptionsubid'];
                $cost = unserialize($sub['cost']);
                $currency = $this->registry->GPC['unit'];
                $amount = intval(ceil($cost[$subid]['cost'][$currency] * $this->settings['d2t']));
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, 'https://gooyapay.ir/webservice/rest/PaymentVerification');
				curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode(array(
						'MerchantID' => $this->settings['gpid'],
						'Amount'     => $amount,
						'Authority'  => $this->registry->GPC['Authority']
					)));
				curl_setopt($ch, CURLOPT_HTTPHEADER, array(
						'Content-Type: application/json',
						'Accept: application/json'
					));
				curl_setopt($ch, CURLOPT_TIMEOUT, 30);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
				curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
				$response = curl_exec($ch);
				curl_close($ch);
				$result = json_decode($response);
				if (isset($result->Status) && $result->Status == 100)
				{
                    $this->paymentinfo['currency'] = $currency;
                    $this->paymentinfo['amount'] = $cost[$subid]['cost'][$currency];
                    $this->type = 1;
                    return true;
				}
				elseif (isset($result->Message) && $result->Message != '')
				{
					$this->error = 'Error : ' . $result->Message;
				}
				elseif ($error)
				{
					$this->error = 'Connecting Error : ' . $error;
				}
				else
				{
					$this->error = 'UnExpected Error in connecting to web service';
				}
            }
            else
            {
                $this->error = 'Trasaction Cancelled by user';
            }
        }
        else
        {
            $this->error = 'Duplicate transaction.';
        }
        return false;
    }

    function test()
    {
        if(!empty($this->settings['gpid']) AND !empty($this->settings['d2t'])){
            return true;
        }
        return false;
    }

    function generate_form_html($hash, $cost, $currency, $subinfo, $userinfo, $timeinfo, $extra = [])
    {
        global $vbphrase, $vbulletin, $show;
        $item = $hash;
        $cost = intval(ceil($cost * $this->settings['d2t']));
        $merchantID = $this->settings['gpid'];
        $form['action'] = 'gooyapay.php';
        $form['method'] = 'POST';
        $settings =& $this->settings;
        $templater = vB_Template::create('subscription_payment_gooyapay');
        $templater->register('merchantID', $merchantID);
        $templater->register('cost', $cost);
        $templater->register('currency', $currency);
        $templater->register('item', $item);
        $templater->register('subinfo', $subinfo);
        $templater->register('settings', $settings);
        $templater->register('userinfo', $userinfo);
        $form['hiddenfields'] .= $templater->render();
        return $form;
    }
}

?>